#include "dealer.h"
#include <stdint.h>
#include <limits.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#define CARD_AMOUNT_SUIT 13
#define SUIT_AMOUNT 4
#define CARD_AMOUNT_DECK CARD_AMOUNT_SUIT * SUIT_AMOUNT

int fill_deck(struct card *deck)
{
    puts("заполняем колоду...");
    for(int i = 0; i < SUIT_AMOUNT; i++)
    {
        for (int k = 0; k < CARD_AMOUNT_SUIT; k++)
        {
            deck[k + i * CARD_AMOUNT_SUIT].rang = k;
            deck[k + i * CARD_AMOUNT_SUIT].suit = i;
        }
    }
    return 0;
}
static uint8_t get_num()
{
    int fd = open("/dev/urandom", O_RDONLY);
    if (fd < 0) {
        return -1;
    }
    uint8_t c;
    do{
        read(fd, &c, 1);
        if(c == EOF){
            close(fd);
            return -2;
        }
    }while(c >= (UCHAR_MAX + 1) / CARD_AMOUNT_DECK * CARD_AMOUNT_DECK);
    close(fd);
    return abs(c % CARD_AMOUNT_DECK);
}

int shuffle_deck(struct card *deck)
{
    for(int i = 0, k = 0; i < 1000; i++, k++){
        if(k >= CARD_AMOUNT_DECK){
            k = 0;
        }
        uint8_t chg_card = get_num();
        if (chg_card >= CARD_AMOUNT_DECK || chg_card < 0){
            return 1;
        }
        struct card tmp = deck[k];
        deck[k] = deck[chg_card];
        deck[chg_card] = tmp;

    }    
    return 0;
}

